Updated asterisk package.
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.1" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34
35 IPFVER="full" # Which versions should be compiled? (full|devel)
36
37 # Debian specific settings
38 if [ ! -e /etc/debian_version ]; then
39 FULLPATH=`which $0`
40 else
41 if [ -x /usr/bin/realpath ]; then
42 FULLPATH=`/usr/bin/realpath $0`
43 else
44 echo "ERROR: Need to do apt-get install realpath"
45 exit 1
46 fi
47 fi
48
49 PWD=`pwd`
50 BASENAME=`basename $0`
51 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
52 LOGFILE=$BASEDIR/log/_build.preparation.log
53 export BASEDIR LOGFILE
54 DIR_CHK=$BASEDIR/cache/check
55 mkdir $BASEDIR/log/ 2>/dev/null
56
57 # Include funtions
58 . tools/make-functions
59
60 if [ -f .config ]; then
61 . .config
62 else
63 echo -e "${BOLD}No configuration found!${NORMAL}"
64 echo -ne "Do you want to create one (y/N)?"
65 read CREATE_CONFIG
66 echo ""
67 if [ "$CREATE_CONFIG" == "y" ]; then
68 make_config
69 fi
70 fi
71
72 if [ -z $EDITOR ]; then
73 for i in nano emacs vi; do
74 EDITOR=$(which $i 2>/dev/null)
75 if ! [ -z $EDITOR ]; then
76 export EDITOR=$EDITOR
77 break
78 fi
79 done
80 [ -z $EDITOR ] && exiterror "You should have installed an editor."
81 fi
82
83 prepareenv() {
84 ############################################################################
85 # #
86 # Are we running the right shell? #
87 # #
88 ############################################################################
89 if [ ! "$BASH" ]; then
90 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
91 fi
92
93 if [ -z "${BASH_VERSION}" ]; then
94 exiterror "Not running BASH shell."
95 fi
96
97
98 ############################################################################
99 # #
100 # Trap on emergency exit #
101 # #
102 ############################################################################
103 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
104
105
106 ############################################################################
107 # #
108 # Resetting our nice level #
109 # #
110 ############################################################################
111 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
112 renice $NICE $$ > /dev/null
113 if [ `nice` != "$NICE" ]; then
114 beautify message FAIL
115 exiterror "Failed to set correct nice level"
116 else
117 beautify message DONE
118 fi
119
120
121 ############################################################################
122 # #
123 # Checking if running as root user #
124 # #
125 ############################################################################
126 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
127 if [ `id -u` != 0 ]; then
128 beautify message FAIL
129 exiterror "Not building as root"
130 else
131 beautify message DONE
132 fi
133
134
135 ############################################################################
136 # #
137 # Checking for necessary temporary space #
138 # #
139 ############################################################################
140 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
141 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
142 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
143 if (( 2048000 > $BASE_ASPACE )); then
144 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
145 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
146 beautify message FAIL
147 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
148 fi
149 else
150 beautify message DONE
151 fi
152
153 ############################################################################
154 # #
155 # Building Linux From Scratch system #
156 # #
157 ############################################################################
158 # Set umask
159 umask 022
160
161 # Set LFS Directory
162 LFS=$BASEDIR/build
163
164 # Check /tools symlink
165 if [ -h /tools ]; then
166 rm -f /tools
167 fi
168 if [ ! -a /tools ]; then
169 ln -s $BASEDIR/build/tools /
170 fi
171 if [ ! -h /tools ]; then
172 exiterror "Could not create /tools symbolic link."
173 fi
174
175 # Setup environment
176 set +h
177 LC_ALL=POSIX
178 MAKETUNING="-j6"
179 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
180 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
181
182 # Make some extra directories
183 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
184 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
185 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
186 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
187
188 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
189 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
190
191 # Make all sources and proc available under lfs build
192 mount --bind /dev $BASEDIR/build/dev
193 mount --bind /dev/pts $BASEDIR/build/dev/pts
194 mount --bind /dev/shm $BASEDIR/build/dev/shm
195 mount --bind /proc $BASEDIR/build/proc
196 mount --bind /sys $BASEDIR/build/sys
197 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
198 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
199 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
200 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
201 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
202 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
203 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
204 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
205 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
206
207 # This is a temporary hack!!!
208 if [ ! -f /tools/bin/hostname ]; then
209 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
210 fi
211
212 # Run LFS static binary creation scripts one by one
213 export CCACHE_DIR=$BASEDIR/ccache
214 export CCACHE_HASHDIR=1
215
216 # Remove pre-install list of installed files in case user erase some files before rebuild
217 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
218 }
219
220 buildtoolchain() {
221 LOGFILE="$BASEDIR/log/_build.toolchain.log"
222 export LOGFILE
223 ORG_PATH=$PATH
224 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
225 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
226 lfsmake1 ccache
227 lfsmake1 binutils PASS=1
228 lfsmake1 gcc PASS=1
229 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
230 lfsmake1 linux-libc-header
231 lfsmake1 glibc
232 lfsmake1 cleanup-toolchain PASS=1
233 lfsmake1 tcl
234 lfsmake1 expect
235 lfsmake1 dejagnu
236 lfsmake1 gcc PASS=2
237 lfsmake1 binutils PASS=2
238 lfsmake1 ncurses
239 lfsmake1 bash
240 lfsmake1 bzip2
241 lfsmake1 coreutils
242 lfsmake1 diffutils
243 lfsmake1 findutils
244 lfsmake1 gawk
245 lfsmake1 gettext
246 lfsmake1 grep
247 lfsmake1 gzip
248 lfsmake1 m4
249 lfsmake1 make
250 lfsmake1 patch
251 lfsmake1 perl
252 lfsmake1 sed
253 lfsmake1 tar
254 lfsmake1 texinfo
255 lfsmake1 util-linux
256 lfsmake1 cleanup-toolchain PASS=2
257 export PATH=$ORG_PATH
258 }
259
260 buildbase() {
261 LOGFILE="$BASEDIR/log/_build.base.log"
262 export LOGFILE
263 lfsmake2 stage2
264 lfsmake2 linux-libc-header
265 lfsmake2 man-pages
266 lfsmake2 glibc
267 lfsmake2 cleanup-toolchain PASS=3
268 lfsmake2 binutils
269 lfsmake2 gcc
270 lfsmake2 berkeley
271 lfsmake2 coreutils
272 lfsmake2 iana-etc
273 lfsmake2 m4
274 lfsmake2 bison
275 lfsmake2 ncurses
276 lfsmake2 procps
277 lfsmake2 sed
278 lfsmake2 libtool
279 lfsmake2 perl
280 lfsmake2 readline
281 lfsmake2 zlib
282 lfsmake2 autoconf
283 lfsmake2 automake
284 lfsmake2 bash
285 lfsmake2 bzip2
286 lfsmake2 diffutils
287 lfsmake2 e2fsprogs
288 lfsmake2 ed
289 lfsmake2 file
290 lfsmake2 findutils
291 lfsmake2 flex
292 lfsmake2 gawk
293 lfsmake2 gettext
294 lfsmake2 grep
295 lfsmake2 groff
296 lfsmake2 gzip
297 lfsmake2 inetutils
298 lfsmake2 iproute2
299 lfsmake2 kbd
300 lfsmake2 less
301 lfsmake2 libaal
302 lfsmake2 make
303 lfsmake2 man
304 lfsmake2 mktemp
305 lfsmake2 modutils
306 lfsmake2 mtd
307 lfsmake2 net-tools
308 lfsmake2 patch
309 lfsmake2 psmisc
310 lfsmake2 reiser4progs
311 lfsmake2 shadow
312 lfsmake2 sysklogd
313 lfsmake2 sysvinit
314 lfsmake2 tar
315 lfsmake2 texinfo
316 lfsmake2 udev
317 lfsmake2 util-linux
318 lfsmake2 vim
319 lfsmake2 grub
320 }
321
322 buildipfire() {
323 LOGFILE="$BASEDIR/log/_build.ipfire.log"
324 export LOGFILE
325 ipfiremake configroot
326 ipfiremake backup
327 ipfiremake dhcp
328 ipfiremake dhcpcd
329 ipfiremake libusb
330 ipfiremake libpcap
331 ipfiremake ppp
332 ipfiremake rp-pppoe
333 ipfiremake unzip
334 ipfiremake linux SMP=1
335 ipfiremake ipp2p SMP=1
336 ipfiremake zaptel SMP=1
337 ipfiremake r8169 SMP=1
338 ipfiremake r8168 SMP=1
339 ipfiremake mcs7830 SMP=1
340 ipfiremake atl1 SMP=1
341 ipfiremake dm9601 SMP=1
342 ipfiremake kqemu SMP=1
343 ipfiremake sane KMOD=1 SMP=1
344 ipfiremake linux
345 ipfiremake ipp2p
346 ipfiremake zaptel
347 ipfiremake r8169
348 ipfiremake r8168
349 ipfiremake mcs7830
350 ipfiremake atl1
351 ipfiremake dm9601
352 ipfiremake kqemu
353 ipfiremake sane KMOD=1
354 ipfiremake pkg-config
355 ipfiremake linux-atm
356 ipfiremake cpio
357 ipfiremake klibc
358 ipfiremake mkinitcpio
359 ipfiremake udev KLIBC=1
360 ipfiremake expat
361 ipfiremake gdbm
362 ipfiremake gmp
363 ipfiremake pam
364 ipfiremake openssl
365 ipfiremake curl
366 ipfiremake python
367 ipfiremake libnet
368 ipfiremake libidn
369 ipfiremake libjpeg
370 ipfiremake libpng
371 ipfiremake libtiff
372 ipfiremake libart
373 ipfiremake freetype
374 ipfiremake gd
375 ipfiremake popt
376 ipfiremake pcre
377 ipfiremake slang
378 ipfiremake newt
379 ipfiremake libcap
380 ipfiremake pciutils
381 ipfiremake usbutils
382 ipfiremake libxml2
383 ipfiremake libxslt
384 ipfiremake BerkeleyDB
385 ipfiremake mysql
386 ipfiremake cyrus-sasl
387 ipfiremake openldap
388 ipfiremake apache2
389 ipfiremake php
390 ipfiremake apache2 PASS=C
391 ipfiremake arping
392 ipfiremake beep
393 ipfiremake bind
394 ipfiremake cdrtools
395 ipfiremake dnsmasq
396 ipfiremake dosfstools
397 ipfiremake squashfstools
398 ipfiremake reiserfsprogs
399 ipfiremake xfsprogs
400 ipfiremake sysfsutils
401 ipfiremake fuse
402 ipfiremake ntfs-3g
403 ipfiremake ethtool
404 ipfiremake ez-ipupdate
405 ipfiremake fcron
406 ipfiremake perl-GD
407 ipfiremake GD-Graph
408 ipfiremake GD-TextUtil
409 ipfiremake gnupg
410 ipfiremake hdparm
411 ipfiremake sdparm
412 ipfiremake mtools
413 ipfiremake initscripts
414 ipfiremake whatmask
415 ipfiremake iptables
416 ipfiremake libupnp
417 ipfiremake ipp2p IPT=1
418 ipfiremake linux-igd
419 ipfiremake ipac-ng
420 ipfiremake ipaddr
421 ipfiremake iptstate
422 ipfiremake iputils
423 ipfiremake l7-protocols
424 ipfiremake mISDN
425 ipfiremake capi4k-utils
426 ipfiremake hwdata
427 ipfiremake kudzu
428 ipfiremake logrotate
429 ipfiremake logwatch
430 ipfiremake misc-progs
431 ipfiremake nano
432 ipfiremake nasm
433 ipfiremake URI
434 ipfiremake HTML-Tagset
435 ipfiremake HTML-Parser
436 ipfiremake Compress-Zlib
437 ipfiremake Digest
438 ipfiremake Digest-SHA1
439 ipfiremake Digest-HMAC
440 ipfiremake libwww-perl
441 ipfiremake Net-DNS
442 ipfiremake Net-IPv4Addr
443 ipfiremake Net_SSLeay
444 ipfiremake IO-Stringy
445 ipfiremake Unix-Syslog
446 ipfiremake Mail-Tools
447 ipfiremake MIME-Tools
448 ipfiremake Net-Server
449 ipfiremake Convert-TNEF
450 ipfiremake Convert-UUlib
451 ipfiremake Archive-Tar
452 ipfiremake Archive-Zip
453 ipfiremake Text-Tabs+Wrap
454 ipfiremake Locale-Country
455 ipfiremake XML-Parser
456 ipfiremake glib
457 ipfiremake GeoIP
458 ipfiremake fwhits
459 ipfiremake noip_updater
460 ipfiremake ntp
461 ipfiremake openssh
462 ipfiremake openswan
463 ipfiremake rrdtool
464 ipfiremake setserial
465 ipfiremake setup
466 ipfiremake snort
467 ipfiremake oinkmaster
468 ipfiremake squid
469 ipfiremake squid-graph
470 ipfiremake squidguard
471 ipfiremake calamaris
472 ipfiremake tcpdump
473 ipfiremake traceroute
474 ipfiremake vlan
475 ipfiremake wireless
476 ipfiremake libsafe
477 ipfiremake pakfire
478 ipfiremake java
479 ipfiremake spandsp
480 ipfiremake lzo
481 ipfiremake openvpn
482 ipfiremake pammysql
483 ipfiremake cups
484 ipfiremake ghostscript
485 ipfiremake foomatic
486 ipfiremake hplip
487 ipfiremake samba
488 ipfiremake sudo
489 ipfiremake mc
490 ipfiremake wget
491 ipfiremake bridge-utils
492 ipfiremake screen
493 ipfiremake hddtemp
494 ipfiremake smartmontools
495 ipfiremake htop
496 ipfiremake postfix
497 ipfiremake fetchmail
498 ipfiremake cyrus-imapd
499 ipfiremake openmailadmin
500 ipfiremake clamav
501 ipfiremake spamassassin
502 ipfiremake amavisd
503 ipfiremake alsa
504 ipfiremake mpg123
505 ipfiremake mpfire
506 ipfiremake guardian
507 ipfiremake libid3tag
508 ipfiremake libmad
509 ipfiremake libogg
510 ipfiremake libvorbis
511 ipfiremake lame
512 ipfiremake sox
513 ipfiremake libshout
514 ipfiremake icecast
515 ipfiremake icegenerator
516 ipfiremake mpd
517 ipfiremake mpc
518 ipfiremake xvid
519 ipfiremake libmpeg2
520 ipfiremake videolan
521 ipfiremake cmake
522 ipfiremake libpri
523 ipfiremake asterisk
524 ipfiremake gnump3d
525 ipfiremake libsigc++
526 ipfiremake applejuice
527 ipfiremake ocaml
528 ipfiremake mldonkey
529 ipfiremake libtorrent
530 ipfiremake rtorrent
531 ipfiremake ipfireseeder
532 ipfiremake rsync
533 ipfiremake tcpwrapper
534 ipfiremake portmap
535 ipfiremake nfs
536 ipfiremake nmap
537 ipfiremake mbmon
538 ipfiremake ncftp
539 ipfiremake etherwake
540 ipfiremake bwm-ng
541 ipfiremake tripwire
542 ipfiremake sysstat
543 ipfiremake vsftpd
544 ipfiremake which
545 ipfiremake lsof
546 ipfiremake centerim
547 ipfiremake br2684ctl
548 ipfiremake pcmciautils
549 ipfiremake collectd
550 ipfiremake lcd4linux
551 ipfiremake neon
552 ipfiremake subversion
553 ipfiremake tcptrack
554 ipfiremake teamspeak
555 ipfiremake elinks
556 ipfiremake igmpproxy
557 ipfiremake sdl
558 ipfiremake qemu
559 ipfiremake sane
560 ipfiremake netpbm
561 ipfiremake phpSANE
562 ipfiremake tunctl
563 ipfiremake nagios
564 ipfiremake ebtables
565 ipfiremake arptables
566 ipfiremake fontconfig
567 ipfiremake freefont
568 ipfiremake vdr
569 ipfiremake git
570 ipfiremake squidclamav
571 ipfiremake bc
572 }
573
574 buildinstaller() {
575 # Run installer scripts one by one
576 LOGFILE="$BASEDIR/log/_build.installer.log"
577 export LOGFILE
578 ipfiremake syslinux
579 ipfiremake as86
580 ipfiremake mbr
581 ipfiremake memtest
582 installmake linux-libc-header
583 installmake binutils
584 ipfiremake uClibc PASS=1
585 ipfiremake gcc INST=1
586 installmake uClibc PASS=2
587 installmake gcc INST=2
588 installmake uClibc PASS=3
589 installmake busybox
590 installmake udev
591 installmake slang
592 installmake newt
593 installmake gettext
594 installmake kbd
595 installmake popt
596 installmake sysvinit
597 installmake misc-progs
598 installmake libaal
599 installmake reiser4progs
600 installmake reiserfsprogs
601 installmake sysfsutils
602 installmake util-linux
603 installmake pciutils
604 installmake zlib
605 installmake mtd
606 installmake wget
607 installmake hwdata
608 installmake kudzu
609 installmake pcmciautils
610 installmake installer
611 installmake initrd
612 }
613
614 buildpackages() {
615 LOGFILE="$BASEDIR/log/_build.packages.log"
616 export LOGFILE
617 echo "... see detailed log in _build.*.log files" >> $LOGFILE
618
619 installmake strip
620
621 # Generating list of packages used
622 echo -n "Generating packages list from logs" | tee -a $LOGFILE
623 rm -f $BASEDIR/doc/packages-list
624 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
625 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
626 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
627 fi
628 done
629 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
630 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
631 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
632 rm -f $BASEDIR/doc/packages-list
633 # packages-list.txt is ready to be displayed for wiki page
634 beautify message DONE
635
636 # Create images for install
637 ipfiremake cdrom ED=full
638
639 # Check if there is a loop device for building in virtual environments
640 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
641 ipfiremake usb-stick
642 fi
643 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
644
645 ipfirepackages
646
647 # Cleanup
648 stdumount
649 rm -rf $BASEDIR/build/tmp/*
650
651 # Generating total list of files
652 echo -n "Generating files list from logs" | tee -a $LOGFILE
653 rm -f $BASEDIR/log/FILES
654 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
655 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
656 echo "##" >>$BASEDIR/log/FILES
657 echo "## `basename $i`" >>$BASEDIR/log/FILES
658 echo "##" >>$BASEDIR/log/FILES
659 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
660 fi
661 done
662 beautify message DONE
663
664 cd $PWD
665 }
666
667 ipfirepackages() {
668 ipfiremake core-updates
669 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
670 if [ -e $BASEDIR/lfs/$i ]; then
671 ipfiredist $i
672 else
673 echo -n $i
674 beautify message SKIP
675 fi
676 done
677 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
678 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
679 rm -rf $BASEDIR/build/install/packages/*
680 }
681
682 # See what we're supposed to do
683 case "$1" in
684 build)
685 clear
686 BUILDMACHINE=`uname -m`
687 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
688 #only restore on a clean disk
689 if [ ! -f log/cleanup-toolchain-2-tools ]; then
690 if [ ! -n "$PACKAGE" ]; then
691 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
692 prepareenv
693 buildtoolchain
694 else
695 PACKAGENAME=${PACKAGE%.tar.gz}
696 beautify build_stage "Packaged toolchain compilation"
697 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
698 tar zxf $PACKAGE
699 prepareenv
700 else
701 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
702 fi
703 fi
704 else
705 echo -n "Using installed toolchain" | tee -a $LOGFILE
706 beautify message SKIP
707 prepareenv
708 fi
709
710 beautify build_start
711 beautify build_stage "Building LFS"
712 buildbase
713
714 beautify build_stage "Building IPFire"
715 buildipfire
716
717 beautify build_stage "Building installer"
718 buildinstaller
719
720 beautify build_stage "Building packages"
721 buildpackages
722 beautify build_end
723 ;;
724 shell)
725 # enter a shell inside LFS chroot
726 # may be used to changed kernel settings
727 prepareenv
728 entershell
729 ;;
730 clean)
731 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
732 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
733 $LOSETUP -d $i 2>/dev/null
734 done
735 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
736 umount $i
737 done
738 stdumount
739 for i in `seq 0 7`; do
740 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
741 umount /dev/loop${i} 2>/dev/null;
742 losetup -d /dev/loop${i} 2>/dev/null;
743 fi;
744 done
745 rm -rf $BASEDIR/build
746 rm -rf $BASEDIR/cdrom
747 rm -rf $BASEDIR/packages
748 rm -rf $BASEDIR/log
749 if [ -h /tools ]; then
750 rm -f /tools
751 fi
752 beautify message DONE
753 ;;
754 downloadsrc)
755 if [ ! -d $BASEDIR/cache ]; then
756 mkdir $BASEDIR/cache
757 fi
758 mkdir -p $BASEDIR/log
759 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
760 FINISHED=0
761 cd $BASEDIR/lfs
762 for c in `seq $MAX_RETRIES`; do
763 if (( FINISHED==1 )); then
764 break
765 fi
766 FINISHED=1
767 cd $BASEDIR/lfs
768 for i in *; do
769 if [ -f "$i" -a "$i" != "Config" ]; then
770 echo -ne "Loading $i"
771 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
772 if [ $? -ne 0 ]; then
773 beautify message FAIL
774 FINISHED=0
775 else
776 if [ $c -eq 1 ]; then
777 beautify message DONE
778 fi
779 fi
780 fi
781 done
782 done
783 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
784 ERROR=0
785 for i in *; do
786 if [ -f "$i" -a "$i" != "Config" ]; then
787 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
788 if [ $? -ne 0 ]; then
789 echo -ne "MD5 difference in lfs/$i"
790 beautify message FAIL
791 ERROR=1
792 fi
793 fi
794 done
795 if [ $ERROR -eq 0 ]; then
796 echo -ne "${BOLD}all files md5sum match${NORMAL}"
797 beautify message DONE
798 else
799 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
800 beautify message FAIL
801 fi
802 cd - >/dev/null 2>&1
803 ;;
804 toolchain)
805 clear
806 prepareenv
807 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
808 buildtoolchain
809 BUILDMACHINE=`uname -m`
810 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
811 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
812 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
813 build/{bin,etc,usr/bin,usr/local} \
814 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
815 log >> $LOGFILE
816 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
817 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
818 stdumount
819 ;;
820 gettoolchain)
821 BUILDMACHINE=`uname -m`
822 # arbitrary name to be updated in case of new toolchain package upload
823 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
824 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
825 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
826 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
827 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
828 cd $BASEDIR/cache/toolchains
829 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
830 if [ $? -ne 0 ]; then
831 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
832 else
833 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
834 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
835 else
836 exiterror "$PACKAGE.md5 did not match, check downloaded package"
837 fi
838 fi
839 else
840 echo "Toolchain is already downloaded. Exiting..."
841 fi
842 ;;
843 othersrc)
844 prepareenv
845 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
846 chroot $LFS /tools/bin/env -i HOME=/root \
847 TERM=$TERM PS1='\u:\w\$ ' \
848 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
849 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
850 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
851 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
852 if [ $? -eq "0" ]; then
853 beautify message DONE
854 else
855 beautify message FAIL
856 fi
857 stdumount
858 ;;
859 git)
860 case "$2" in
861 update|up)
862 git pull
863 ;;
864 commit|ci)
865 shift 2
866 git commit $*
867
868 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
869
870 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
871 read
872 [ -z $REPLY ] && exit 0
873 for i in y Y j J; do
874 if [ "$i" == "$REPLY" ]; then
875 $0 git push
876 exit $?
877 fi
878 done
879 exiterror "\"$REPLY\" is not a valid answer."
880 ;;
881 dist)
882 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
883 ;;
884 diff|di)
885 echo -ne "Make a local diff to last revision"
886 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
887 evaluate 1
888 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
889 git diff --stat
890 ;;
891 push)
892 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
893 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
894
895 git push ${GIT_URL} master
896 ;;
897 esac
898 ;;
899 uploadsrc)
900 PWD=`pwd`
901 cd $BASEDIR/cache/
902 echo -e "Uploading cache to ftp server:"
903 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
904 for i in *; do
905 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
906 grep -q $(basename $i) /tmp/ftplist
907 if [ "$?" -ne "0" ]; then
908 echo -ne "$(basename $i)"
909 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
910 if [ "$?" -ne "0" ]; then
911 beautify message FAIL
912 fi
913 fi
914 done
915 rm -f /tmp/ftplist
916 cd $PWD
917 exit 0
918 ;;
919 upload)
920 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
921 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
922 if [ -z $FTP_ISO_PORT ]; then
923 FTP_ISO_PORT=21
924 fi
925 cat <<EOF > .ftp-commands
926 mkdir -p $FTP_ISO_PATH$SVN_REVISION
927 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
928 quit
929 EOF
930 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
931 rm -f .ftp-commands
932
933 case "$2" in
934 iso)
935 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
936
937 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
938 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
939 if [ -e "$i" ]; then
940 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
941 if [ "$?" -eq "0" ]; then
942 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
943 else
944 echo "There was an error while uploading the file $i to the ftp server."
945 exit 1
946 fi
947 fi
948 done
949 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
950 if [ "$3" = "--with-sources-cd" ]; then
951 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
952 fi
953 ;;
954 paks)
955 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
956 if [ "$?" -eq "0" ]; then
957 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
958 else
959 echo -e "There was an error while uploading the packages to the ftp server."
960 exit 1
961 fi
962 ;;
963 esac
964 ;;
965 batch)
966 if [ "$2" = "--background" ]; then
967 batch_script
968 exit $?
969 fi
970 if [ `screen -ls | grep -q ipfire` ]; then
971 echo "Build is already running, sorry!"
972 exit 1
973 else
974 if [ "$2" = "--rebuild" ]; then
975 export IPFIRE_REBUILD=1
976 echo "REBUILD!"
977 else
978 export IPFIRE_REBUILD=0
979 fi
980 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
981 screen -dmS ipfire $0 batch --background
982 evaluate 1
983 exit 0
984 fi
985 ;;
986 watch)
987 watch_screen
988 ;;
989 pxe)
990 case "$2" in
991 start)
992 start_tftpd
993 ;;
994 stop)
995 stop_tftpd
996 ;;
997 reload|restart)
998 reload_tftpd
999 ;;
1000 esac
1001 exit 0
1002 ;;
1003 lang)
1004 update_langs
1005 ;;
1006 "")
1007 clear
1008 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1009 do
1010 case $name in
1011 "IPFIRE: Downloadsrc")
1012 $0 downloadsrc
1013 ;;
1014 "IPFIRE: Build (silent)")
1015 $0 build-silent
1016 ;;
1017 "IPFIRE: Watch Build")
1018 $0 watch
1019 ;;
1020 "IPFIRE: Batch")
1021 $0 batch
1022 ;;
1023 "IPFIRE: Clean")
1024 $0 clean
1025 ;;
1026 "Help")
1027 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1028 cat doc/make.sh-usage
1029 ;;
1030 "LOG: Tail")
1031 tail -f log/_*
1032 ;;
1033 "Exit")
1034 break
1035 ;;
1036 esac
1037 done
1038 ;;
1039 config)
1040 make_config
1041 ;;
1042 *)
1043 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1044 cat doc/make.sh-usage
1045 ;;
1046 esac